Attribute VB_Name = "Module2"
Option Explicit

Sub AddNick(Nick As String, User As String, RealName As String, HighLight As Boolean, Host As String)
    Dim IRCU As IRCUser
    Dim Channel As Integer, Found As Boolean
    
    Nick = CutOp(Nick)
    
    For Channel = 1 To Hosts(Host).Channels.Count
        Found = False
        For Each IRCU In Hosts(Host).Channels(Channel).IRCUsers                   'Update if there
            If IRCU.Nick = Nick Then
                If User <> "" Then
                    IRCU.User = User
                    Dim Item As Integer
                     For Item = 1 To Hosts(Host).Channels(Channel).Window.List1.ListItems.Count
                         If UCase(CutOp(Hosts(Host).Channels(Channel).Window.List1.ListItems(Item).Text)) = UCase(Nick) Then
                             Hosts(Host).Channels(Channel).Window.List1.ListItems(Item).SubItems(1) = User
                         End If
                    Next Item
                End If
                If RealName <> "" Then IRCU.RealName = RealName
                IRCU.HighLight = HighLight
                Found = True
                Exit For
            End If
        Next
        If Not Found Then NewNick Nick, User, RealName, HighLight, Host, Channel
    Next Channel
End Sub

Sub ChangeNick(Nick As String, NewNick As String, Host As String)
    Dim IRCU As IRCUser
    Dim Channel As Integer, User As Integer
    
    Nick = CutOp(Nick)
    
    For Channel = 1 To Hosts(Host).Channels.Count
        For User = 1 To Hosts(Host).Channels(Channel).IRCUsers.Count
            If Hosts(Host).Channels(Channel).IRCUsers(User).Nick = Nick Then
                Set IRCU = Hosts(Host).Channels(Channel).IRCUsers(User)
                Hosts(Host).Channels(Channel).IRCUsers.Remove User
                IRCU.Nick = NewNick
                Hosts(Host).Channels(Channel).IRCUsers.Add IRCU, NewNick
                Exit For
            End If
        Next
    Next Channel
End Sub


Function CutOp(Nick As String) As String
    If Left(Nick, 1) = "@" Or Left(Nick, 1) = "+" Then Nick = Right(Nick, Len(Nick) - 1)
    If Right(Nick, 1) = "*" Then Nick = Left(Nick, Len(Nick) - 1)
    CutOp = Nick
End Function


Sub DelNick(Nick As String, Host As String)
    Dim IRCU As IRCUser
    Dim Channel As Integer, User As Integer
    
    Nick = CutOp(Nick)
    
    For Channel = 1 To Hosts(Host).Channels.Count
        For User = 1 To Hosts(Host).Channels(Channel).IRCUsers.Count
            If Hosts(Host).Channels(Channel).IRCUsers(User).Nick = Nick Then
                Hosts(Host).Channels(Channel).IRCUsers.Remove User
                'debug.print "removed "; User
                Exit For
            End If
        Next
    Next Channel
End Sub
Sub NewNick(Nick As String, User As String, RealName As String, HighLight As Boolean, Host As String, Channel As Integer)
    
    Dim NewUser As New IRCUser
    NewUser.Nick = Nick
    NewUser.User = User
    NewUser.RealName = RealName
    NewUser.HighLight = HighLight
    
    On Error GoTo schon_da
    Hosts(Host).Channels(Channel).IRCUsers.Add NewUser, Nick
    Exit Sub
    
schon_da:
    Resume Next
End Sub


